//=============================================================================
// abc.js
//=============================================================================
/*:ja
 * @plugindesc abc
 * @author me-
 * @help 
 汎用性を考慮しない専用プラグイン。
 
  * @param TIME_COMMON_ID
 * @desc 時間経過で呼び出すコモンイベント
 * @default 1
 */
 //console.log

(function() {
	var parameters = PluginManager.parameters('abc');
    Game_Chronus.prototype.getValuePadding = function(value, digit, padChar) {
        if (this._disablePadding) {
            return value;
        }
        if (arguments.length === 2) padChar = ' ';
        var result = '';
        for (var i = 0; i < digit; i++) result += padChar;
        result += value;
        return result.substr(-digit);
    };
    // 昼夜管理用の改変
    var time_common_id = parseInt(parameters['TIME_COMMON_ID'] || 1);
    var _Window_Chronus_refresh0914 = Window_Chronus.prototype.refresh;
    Window_Chronus.prototype.refresh = function() {
        _Window_Chronus_refresh0914.call(this);
        let hour = $gameSystem.chronus().getHour();
        if(this._hour != hour){
        	this._hour = hour;
        	$gameSwitches.setValue(87, true);
        	//$gameTemp.reserveCommonEvent(time_common_id);
        	//console.log($gameSystem.chronus().getHour());
        }
    };
    
    //this.symbol_mark();
	Game_CharacterBase.prototype.symbol_mark = function(id) {
		if(!this.isBalloonPlaying() && !$gameMap.isEventRunning()){
			this._balloonLoop = id;
			this.requestBalloon(id);
		}
	};
	Game_CharacterBase.prototype.symbol_markB = function(id) {
		if($gameVariables.value(82)  < 0&& !this.isBalloonPlaying() && !$gameMap.isEventRunning()){
			this._balloonLoop = id;
			this.requestBalloon(id);
		}
	};
	Game_CharacterBase.prototype.balloonLoopId = function() {
		return this._balloonLoop;
		
	};
	Game_CharacterBase.prototype.isBalloonLoop = function() {
		return this._balloonLoop && !$gameMap.isEventRunning();
	};
	Sprite_Character.prototype.endBalloon = function() {
	    if (this._balloonSprite) {
	    		if(this._character.isBalloonLoop()){
	    			this._balloonSprite.setup(this._character.balloonLoopId());
	    		}else{
		        this.parent.removeChild(this._balloonSprite);
		        this._balloonSprite = null;
	        }
	    }
	};
	
	// 手抜きするための細工
	DataManager.extractMetadata = function(data) {
	    var re = /<([^<>:;]+)([:;]?)(.*?)>/g;
	    data.meta = {};
	    for (;;) {
	        var match = re.exec(data.note);
	        if (match) {
	            if (match[2] === ':') {
	                data.meta[match[1]] = match[3];
			} else if (match[2] === ';') {
				data.meta[match[1]] = JSON.parse(match[3]);
			} else {
	                data.meta[match[1]] = true;
	            }
	        } else {
	            break;
	        }
	    }
	};
	
	//　アイテムの最大数の変更
	Game_Party.prototype.maxItems = function(item) {
		return parseInt(item.meta.max || 99);
	};
	
	//----------------------------------------------------------------------------
	// キーアイテムの種類を制限
	//
	// $evetnItemKey = "";
	Window_EventItem.prototype.includes = function(item) {
	    var itypeId = $gameMessage.itemChoiceItypeId();
	    if($evetnItemKey){
	    	return DataManager.isItem(item) && item.itypeId === itypeId && (item.meta.key && item.meta.key.indexOf($evetnItemKey) > -1);
	    }
	    return DataManager.isItem(item) && item.itypeId === itypeId;
	};
	//----------------------------------------------------------------------------
	// キーアイテムを持っているか?を調べる
	//
	// $gameParty.isAllKeyItem("");
	Game_Party.prototype.isAllKeyItem = function(key) {
	    for (var id in this._items) {
	        var item = $dataItems[id];
	        if(item.meta.key && item.meta.key.indexOf(key) > -1){
	        	return true;
	        }
	    }
	    return false;
	};
	//
	Game_Party.prototype.maxAllKeyItemLost = function(key) {
	 var n = 0, i_id = -1;
	    for (var id in this._items) {
	        var item = $dataItems[id];
	        if(item.meta.key && item.meta.key.indexOf(key) > -1 && n < this._items[id]){
	        	n = this._items[id];
	        	i_id = id;
	        }
	    }
	    if(i_id != -1){
	     var i = Math.ceil(this._items[i_id] / 2);
	    	$gameVariables.setValue(108, i);
	    	$gameParty.gainItem($dataItems[i_id], -i, false);
	    }
	    $gameVariables.setValue(107, i_id);
	};
	// 数字入力の上限を設定。
	Window_NumberInput.prototype.changeDigit = function(up) {
	    var index = this.index();
	    var place = Math.pow(10, this._maxDigits - 1 - index);
	    var n = Math.floor(this._number / place) % 10;
	    this._number -= n * place;
	    if (up) {
	        n = (n + 1) % 10;
	    } else {
	        n = (n + 9) % 10;
	    }
	    this._number += n * place;
	    var i = $gameVariables.value(40);
	    
	    if(i != 0){
	    	this._number = Math.min(this._number, i);
	    }
	    this.refresh();
	    SoundManager.playCursor();
	};
	
	
})();

